Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.fujitsu.iflow.model.workflow
Interface Dashboard

public interface Dashboard

The Dashboard interface provides methods to get templates, processes and activities and to analyze their states, their cycle times and their waiting times. Additionaly are provided some methods to manage the Key Perfomance Indicator (KPI).

Method Summary
`void` | `addKPI(KPIDefStruct kpiDefStruct)` Adds the Key Performance Indicator(KPI) information into the database table.
`void` | `deleteKPIDef(long kpiId)` Deletes the Key Performance Indicator (KPI) definition from the database.
`long` | `getActivityCycleTime(long actDefId)` Returns the average cycle time in milis for all completed/closed activites for a given activity definition.
`long` | `getActivityWaitTime(long actDefId)` Returns the average waiting time in milis for all the active/running activities for a given activity definition.
`java.util.Hashtable` | `getAllActivities(long procDefId)`
`long` | `getAllProcessesWaiting()` Returns the number of all active/running processes currently found in the system.
`java.util.Hashtable` | `getAllTemplates()`
`long` | `getAvgTimeAllActivity()` Returns the average waiting time in milis for all active/running activites currently located in the system.
`long` | `getAvgTimeAllProcesses()` Returns the average waiting time in milis for all running/active processes currently located in the system.
`KPIDefStruct[]` | `getKPIThresholdDefs()` Returns all Key Performance Indicator(KPI) definition structures.
`long` | `getKPIValue(long kpiid)` Based on the Key Performance Indicator (KPI) ID, the scope of the KPI and the KPI measure, this method invokes the appropriate method in order to compute the KPI value for the given KPI ID and returns the computed KPI value.
`long` | `getNoOfActivitiesWaiting(long actDefId)` Returns the number of waiting activites on a given activity definition.
`long` | `getNoOfProcessesWaiting(long procDefId)` Returns the number of running/active processes for a given process definition.
`long` | `getProcessCycleTime(long procDefId)` Returns the average cycle time in milis for all closed processes for a given process definition.
`long` | `getProcessWaitTime(long procDefId)` Returns the average waiting time in milis for all running/active processes on a given process definition.
`void` | `updateKPIDef(KPIDefStruct kpiDefStruct)` Updates the Key Performance Indicator(KPI) definition structures in the database.

Method Detail

### getActivityWaitTime

    public long getActivityWaitTime(long actDefId)
                             throws ModelException

  Returns the average waiting time in milis for all the active/running activities for a given activity definition.

  Parameters:
    `actDefId` - The ID of the activity definition for which the waiting time of all active activities has to be computed.
  Returns:
    The average waiting time in milis for all the active/running activities or '-1' if no active/running actvites are found.
  Throws:
    `ModelException`

### getNoOfActivitiesWaiting

    public long getNoOfActivitiesWaiting(long actDefId)
                                  throws ModelException

  Returns the number of waiting activites on a given activity definition.

  Parameters:
    `actDefId` - The ID of the activity definition to which the waiting activities to be found.
  Returns:
    The number of waiting activites or '0' if no waiting activites are found.
  Throws:
    `ModelException`

### getActivityCycleTime

    public long getActivityCycleTime(long actDefId)
                              throws ModelException

  Returns the average cycle time in milis for all completed/closed activites for a given activity definition.

  Parameters:
    `actDefId` - The ID of the activity definition to be used to find all the completed activites.
  Returns:
    The average cycle time in milis for all the completed/closed activities or '-1' if no closed activites are found.
  Throws:
    `ModelException`

### getProcessWaitTime

    public long getProcessWaitTime(long procDefId)
                            throws ModelException

  Returns the average waiting time in milis for all running/active processes on a given process definition.

  Parameters:
    `procDefId` - The ID of the process definition to be used to find all the active/running processes.
  Returns:
    The average waiting time in milis for all running/active processes or '-1' if no active/running processes are found.
  Throws:
    `ModelException`

### getNoOfProcessesWaiting

    public long getNoOfProcessesWaiting(long procDefId)
                                 throws ModelException

  Returns the number of running/active processes for a given process definition.

  Parameters:
    `procDefId` - The ID of the process definition to be used to find all active/running processes.
  Returns:
    The total number of active/running processes or '-1' if no active/running processes are found.
  Throws:
    `ModelException`

### getProcessCycleTime

    public long getProcessCycleTime(long procDefId)
                             throws ModelException

  Returns the average cycle time in milis for all closed processes for a given process definition.

  Parameters:
    `procDefId` - The ID of the process definition to be used to find all closed processes.
  Returns:
    The average cycle time in milis for all closed processes or '-1' if no closed processes are found.
  Throws:
    `ModelException`

### getAvgTimeAllActivity

    public long getAvgTimeAllActivity()
                               throws ModelException

  Returns the average waiting time in milis for all active/running activites currently located in the system.

  Returns:
    The average waiting time in milis for all active/running activites or '-1' if no active/running activites are found.
  Throws:
    `ModelException`

### getAvgTimeAllProcesses

    public long getAvgTimeAllProcesses()
                                throws ModelException

  Returns the average waiting time in milis for all running/active processes currently located in the system.

  Returns:
    The average waiting time in milis for all active/running processes or '-1' if no activee/running processes are found.
  Throws:
    `ModelException`

### getAllProcessesWaiting

    public long getAllProcessesWaiting()
                                throws ModelException

  Returns the number of all active/running processes currently found in the system.

  Returns:
    The number of active/running processes in the system or '0' if no such processes are found.
  Throws:
    `ModelException`

### getAllActivities

    public java.util.Hashtable getAllActivities(long procDefId)
                                         throws ModelException

  Throws:
    `ModelException`

### getAllTemplates

    public java.util.Hashtable getAllTemplates()
                                        throws ModelException

  Throws:
    `ModelException`

### addKPI

    public void addKPI(KPIDefStruct kpiDefStruct)
                throws ModelException

  Adds the Key Performance Indicator(KPI) information into the database table.

  Parameters:
    `kpiDefStruct` - The KPIDefStruct to be added into the database.
  Throws:
    `ModelException`

### getKPIThresholdDefs

    public KPIDefStruct[] getKPIThresholdDefs()
                                       throws ModelException

  Returns all Key Performance Indicator(KPI) definition structures.

  Returns:
    An array of KPI definition strucures.
  Throws:
    `ModelException`

### updateKPIDef

    public void updateKPIDef(KPIDefStruct kpiDefStruct)
                      throws ModelException

  Updates the Key Performance Indicator(KPI) definition structures in the database.

  Parameters:
    `kpiDefStruct` - KPI defintion structure with the new values to be updated in the database.
  Throws:
    `ModelException`

### deleteKPIDef

    public void deleteKPIDef(long kpiId)
                      throws ModelException

  Deletes the Key Performance Indicator (KPI) definition from the database.

  Parameters:
    `kpiId` - A value of the type long which uniquely identifies the KPI definition to be deleted from the database.
  Throws:
    `ModelException`

### getKPIValue

    public long getKPIValue(long kpiid)
                     throws ModelException

  Based on the Key Performance Indicator (KPI) ID, the scope of the KPI and the KPI measure, this method invokes the appropriate method in order to compute the KPI value for the given KPI ID and returns the computed KPI value.

  Parameters:
    `kpiid` - The KPI ID which uniquely identifies the given KPI, for which the value has to be calculated.
  Returns:
    The KPI value, which will be computed dynamically.
  Throws:
    `ModelException`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD